freedombone-app-tahoelafs 22KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # Tahow-LAFS data storage grid implemented via Tor
  10. # https://k0rx.com/blog/2017/01/lafs.html
  11. # http://tahoe-lafs.readthedocs.io/en/latest/anonymity-configuration.html
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2014-2018 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim cloud'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. SHOW_ICANN_ADDRESS_ON_ABOUT=0
  34. TAHOELAFS_PORT=50213
  35. TAHOELAFS_STORAGE_PORT=50214
  36. TAHOELAFS_ONION_PORT=8096
  37. TAHOELAFS_STORAGE_ONION_PORT=8097
  38. TAHOE_DIR=/home/tahoelafs
  39. TAHOE_COMMAND='/usr/bin/tahoe'
  40. tahoelafs_storage_file=$TAHOE_DIR/client/private/servers.yaml
  41. TAHOELAFS_SHARES_NEEDED=3
  42. TAHOELAFS_SHARES_HAPPY=7
  43. TAHOELAFS_SHARES_TOTAL=10
  44. tahoelafs_variables=(ONION_ONLY
  45. MY_USERNAME
  46. TAHOELAFS_PORT
  47. TAHOELAFS_SHARES_NEEDED
  48. TAHOELAFS_SHARES_HAPPY
  49. TAHOELAFS_SHARES_TOTAL)
  50. function logging_on_tahoelafs {
  51. echo -n ''
  52. }
  53. function logging_off_tahoelafs {
  54. echo -n ''
  55. }
  56. function add_user_tahoelafs {
  57. if [[ $(app_is_installed tahoelafs) == "0" ]]; then
  58. echo '0'
  59. return
  60. fi
  61. new_username="$1"
  62. new_user_password="$2"
  63. "${PROJECT_NAME}-pass" -u "$new_username" -a tahoelafs -p "$new_user_password"
  64. if grep -q "${new_username}:" /etc/nginx/.htpasswd-tahoelafs; then
  65. sed -i "'/${new_username}:/d" /etc/nginx/.htpasswd-tahoelafs
  66. fi
  67. echo "${new_user_password}" | htpasswd -i -s /etc/nginx/.htpasswd-tahoelafs "${new_username}"
  68. echo '0'
  69. }
  70. function remove_user_tahoelafs {
  71. remove_username="$1"
  72. "${PROJECT_NAME}-pass" -u "$remove_username" --rmapp tahoelafs
  73. if grep -q "${remove_username}:" /etc/nginx/.htpasswd-tahoelafs; then
  74. sed -i "/${remove_username}:/d" /etc/nginx/.htpasswd-tahoelafs
  75. fi
  76. }
  77. function change_password_tahoelafs {
  78. change_username="$1"
  79. change_password="$2"
  80. "${PROJECT_NAME}-pass" -u "$change_username" -a tahoelafs -p "$change_password"
  81. if grep -q "${change_username}:" /etc/nginx/.htpasswd-tahoelafs; then
  82. sed -i "/tahoe-${change_username}:/d" /etc/nginx/.htpasswd-tahoelafs
  83. fi
  84. echo "${change_password}" | htpasswd -i -s /etc/nginx/.htpasswd-tahoelafs "${change_username}"
  85. }
  86. function add_tahoelafs_storage_node_interactive {
  87. data=$(mktemp 2>/dev/null)
  88. dialog --backtitle $"Freedombone Configuration" \
  89. --title $"Add Tahoe-LAFS storage node" \
  90. --form $"\\nEnter the storage node details which can be found on the About screen of another server" 13 75 5 \
  91. $"Hostname:" 1 1 "" 1 14 53 40 \
  92. $"Public Key:" 2 1 "" 2 14 53 255 \
  93. $"Nickname:" 3 1 "" 3 14 53 255 \
  94. $"FURL:" 4 1 "" 4 14 53 255 \
  95. 2> "$data"
  96. sel=$?
  97. case $sel in
  98. 1) return;;
  99. 255) return;;
  100. esac
  101. storage_hostname=$(sed -n 1p < "$data")
  102. public_key=$(sed -n 2p < "$data")
  103. nick=$(sed -n 3p < "$data")
  104. furl=$(sed -n 4p < "$data")
  105. rm -f "$data"
  106. if [ ${#public_key} -eq 0 ]; then
  107. return
  108. fi
  109. add_tahoelafs_server "${storage_hostname}" "${public_key}" "${nick}" "${furl}"
  110. if grep -q "$public_key" ${tahoelafs_storage_file}; then
  111. dialog --title $"Add Tahoe-LAFS storage node" \
  112. --msgbox $"Storage node added" 6 40
  113. fi
  114. }
  115. function edit_tahoelafs_nodes {
  116. editor $tahoelafs_storage_file
  117. chown tahoelafs:debian-tor $tahoelafs_storage_file
  118. systemctl restart tahoelafs-client
  119. }
  120. function edit_tahoelafs_shares {
  121. read_config_param TAHOELAFS_SHARES_NEEDED
  122. read_config_param TAHOELAFS_SHARES_HAPPY
  123. read_config_param TAHOELAFS_SHARES_TOTAL
  124. data=$(mktemp 2>/dev/null)
  125. dialog --backtitle $"Freedombone Configuration" \
  126. --title $"Tahoe-LAFS shares" \
  127. --form $"\\nEnter the storage node details which can be found on the About screen of another server" 13 40 3 \
  128. $"Needed:" 1 1 "${TAHOELAFS_SHARES_NEEDED}" 1 14 4 4 \
  129. $"Happy:" 2 1 "${TAHOELAFS_SHARES_HAPPY}" 2 14 4 4 \
  130. $"Total:" 3 1 "${TAHOELAFS_SHARES_TOTAL}" 3 14 4 4 \
  131. 2> "$data"
  132. sel=$?
  133. case $sel in
  134. 1) rm -f "$data"
  135. return;;
  136. 255) rm -f "$data"
  137. return;;
  138. esac
  139. tl_needed=$(sed -n 1p < "$data")
  140. tl_happy=$(sed -n 2p < "$data")
  141. tl_total=$(sed -n 3p < "$data")
  142. rm -f "$data"
  143. if [ ${#tl_needed} -gt 0 ]; then
  144. TAHOELAFS_SHARES_NEEDED=${tl_needed}
  145. fi
  146. if [ ${#tl_happy} -gt 0 ]; then
  147. TAHOELAFS_SHARES_HAPPY=${tl_happy}
  148. fi
  149. if [ ${#tl_total} -gt 0 ]; then
  150. TAHOELAFS_SHARES_TOTAL=${tl_total}
  151. fi
  152. sed -i "s|shares.needed.*|shares.needed = ${TAHOELAFS_SHARES_NEEDED}|g" $TAHOE_DIR/tahoelafs/client/tahoe.cfg
  153. sed -i "s|shares.happy.*|shares.happy = ${TAHOELAFS_SHARES_HAPPY}|g" $TAHOE_DIR/tahoelafs/client/tahoe.cfg
  154. sed -i "s|shares.total.*|shares.total = ${TAHOELAFS_SHARES_TOTAL}|g" $TAHOE_DIR/tahoelafs/client/tahoe.cfg
  155. sed -i "s|shares.needed.*|shares.needed = ${TAHOELAFS_SHARES_NEEDED}|g" $TAHOE_DIR/tahoelafs/storage/tahoe.cfg
  156. sed -i "s|shares.happy.*|shares.happy = ${TAHOELAFS_SHARES_HAPPY}|g" $TAHOE_DIR/tahoelafs/storage/tahoe.cfg
  157. sed -i "s|shares.total.*|shares.total = ${TAHOELAFS_SHARES_TOTAL}|g" $TAHOE_DIR/tahoelafs/storage/tahoe.cfg
  158. systemctl restart tahoelafs-storage
  159. systemctl restart tahoelafs-client
  160. dialog --title $"Tahoe-LAFS shares" \
  161. --msgbox $"Shares settings changed" 6 40
  162. }
  163. function configure_interactive_tahoelafs {
  164. W=(1 $"Add a storage node"
  165. 2 $"Manually edit storage nodes"
  166. 3 $"Shares settings")
  167. while true
  168. do
  169. # shellcheck disable=SC2068
  170. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Tahoe-LAFS" --menu $"Choose an operation, or ESC to exit:" 12 60 3 "${W[@]}" 3>&2 2>&1 1>&3)
  171. if [ ! "$selection" ]; then
  172. break
  173. fi
  174. case $selection in
  175. 1) add_tahoelafs_storage_node_interactive;;
  176. 2) edit_tahoelafs_nodes;;
  177. 3) edit_tahoelafs_shares;;
  178. esac
  179. done
  180. }
  181. function tahoelafs_setup_client_config {
  182. config_file="$1"
  183. nick="$2"
  184. { echo '[node]';
  185. echo "nickname = $nick";
  186. echo 'reveal-IP-address = false';
  187. echo "web.port = tcp:${TAHOELAFS_PORT}:interface=127.0.0.1";
  188. echo 'web.static = public_html';
  189. echo 'tub.port = disabled';
  190. echo 'tub.location = disabled';
  191. echo '';
  192. echo '[client]';
  193. echo 'introducer.furl =';
  194. echo "shares.needed = ${TAHOELAFS_SHARES_NEEDED}";
  195. echo "shares.happy = ${TAHOELAFS_SHARES_HAPPY}";
  196. echo "shares.total = ${TAHOELAFS_SHARES_TOTAL}";
  197. echo '';
  198. echo '[storage]';
  199. echo 'enabled = false';
  200. echo 'reserved_space = 3G';
  201. echo '';
  202. echo '[helper]';
  203. echo 'enabled = false';
  204. echo '';
  205. echo '[connections]';
  206. echo 'tcp = tor'; } > "$config_file"
  207. }
  208. function tahoelafs_setup_storage_config {
  209. config_file="$1"
  210. nick="$2"
  211. { echo '[node]';
  212. echo "nickname = $nick";
  213. echo 'reveal-IP-address = false';
  214. echo 'web.port =';
  215. echo 'web.static = public_html';
  216. echo "tub.port = tcp:${TAHOELAFS_STORAGE_ONION_PORT}:interface=127.0.0.1";
  217. echo "tub.location = tor:${TAHOELAFS_STORAGE_ONION_HOSTNAME}:${TAHOELAFS_STORAGE_PORT}";
  218. echo '';
  219. echo '[client]';
  220. echo 'introducer.furl =';
  221. echo 'helper.furl =';
  222. echo '';
  223. echo "shares.needed = ${TAHOELAFS_SHARES_NEEDED}";
  224. echo "shares.happy = ${TAHOELAFS_SHARES_HAPPY}";
  225. echo "shares.total = ${TAHOELAFS_SHARES_TOTAL}";
  226. echo '';
  227. echo '[storage]';
  228. echo 'enabled = true';
  229. echo 'reserved_space = 3G';
  230. echo 'expire.enabled = true';
  231. echo 'expire.mode = age';
  232. echo 'expire.override_lease_duration = 3 months';
  233. echo '';
  234. echo '[helper]';
  235. echo 'enabled = false';
  236. echo '';
  237. echo '[connections]';
  238. echo 'tcp = tor'; } > "$config_file"
  239. chown -R tahoelafs:debian-tor $TAHOE_DIR
  240. }
  241. function install_interactive_tahoelafs {
  242. echo -n ''
  243. APP_INSTALLED=1
  244. }
  245. function upgrade_tahoelafs {
  246. echo -n ''
  247. }
  248. function backup_local_tahoelafs {
  249. source_directory=$TAHOE_DIR
  250. if [ ! -d $source_directory ]; then
  251. return
  252. fi
  253. systemctl stop tahoelafs
  254. dest_directory=tahoelafs
  255. function_check backup_directory_to_usb
  256. backup_directory_to_usb $source_directory $dest_directory
  257. systemctl start tahoelafs
  258. }
  259. function restore_local_tahoelafs {
  260. echo $"Restoring Tahoe-LAFS"
  261. systemctl stop tahoelafs-storage
  262. systemctl stop tahoelafs-client
  263. temp_restore_dir=/root/temptahoelafs
  264. restore_directory_from_usb $temp_restore_dir tahoelafs
  265. if [ -d $temp_restore_dir$TAHOE_DIR ]; then
  266. mv $TAHOE_DIR ${TAHOE_DIR}-old
  267. cp -r $temp_restore_dir$TAHOE_DIR $TAHOE_DIR
  268. else
  269. cp -r $temp_restore_dir/* $TAHOE_DIR/
  270. fi
  271. # shellcheck disable=SC2181
  272. if [ ! "$?" = "0" ]; then
  273. if [ -d ${TAHOE_DIR}-old ]; then
  274. mv ${TAHOE_DIR}-old $TAHOE_DIR
  275. fi
  276. exit 246833
  277. fi
  278. if [ -d ${TAHOE_DIR}-old ]; then
  279. rm -rf ${TAHOE_DIR}-old
  280. fi
  281. rm -rf $temp_restore_dir
  282. chown -R tahoelafs:debian-tor $TAHOE_DIR
  283. systemctl start tahoelafs-client
  284. systemctl start tahoelafs-storage
  285. echo $"Restore complete"
  286. }
  287. function backup_remote_tahoelafs {
  288. source_directory=$TAHOE_DIR
  289. if [ ! -d $source_directory ]; then
  290. return
  291. fi
  292. systemctl stop tahoelafs-storage
  293. systemctl stop tahoelafs-client
  294. dest_directory=tahoelafs
  295. function_check backup_directory_to_usb
  296. backup_directory_to_friend $source_directory $dest_directory
  297. systemctl start tahoelafs-client
  298. systemctl start tahoelafs-storage
  299. }
  300. function restore_remote_tahoelafs {
  301. echo $"Restoring Tahoe-LAFS"
  302. systemctl stop tahoelafs-storage
  303. systemctl stop tahoelafs-client
  304. temp_restore_dir=/root/temptahoelafs
  305. restore_directory_from_friend $temp_restore_dir tahoelafs
  306. if [ -d $temp_restore_dir$TAHOE_DIR ]; then
  307. mv $TAHOE_DIR ${TAHOE_DIR}-old
  308. cp -r $temp_restore_dir$TAHOE_DIR $TAHOE_DIR
  309. else
  310. cp -r $temp_restore_dir/* $TAHOE_DIR/
  311. fi
  312. # shellcheck disable=SC2181
  313. if [ ! "$?" = "0" ]; then
  314. if [ -d "${TAHOE_DIR}-old" ]; then
  315. # shellcheck disable=SC2086
  316. mv ${TAHOE_DIR}-old $TAHOE_DIR
  317. fi
  318. exit 623925
  319. fi
  320. if [ -d "${TAHOE_DIR}-old" ]; then
  321. rm -rf "${TAHOE_DIR}-old"
  322. fi
  323. rm -rf $temp_restore_dir
  324. chown -R tahoelafs:debian-tor $TAHOE_DIR
  325. systemctl start tahoelafs-client
  326. systemctl start tahoelafs-storage
  327. echo $"Restore complete"
  328. }
  329. function reconfigure_tahoelafs {
  330. if [ -f $tahoelafs_storage_file ]; then
  331. rm $tahoelafs_storage_file
  332. fi
  333. sed -i '/HidServAuth /d' /etc/tor/torrc
  334. }
  335. function remove_tahoelafs {
  336. if [ -f /etc/nginx/sites-available/tahoelafs ]; then
  337. nginx_dissite tahoelafs
  338. rm /etc/nginx/sites-available/tahoelafs
  339. if [ -d /var/www/tahoelafs ]; then
  340. rm -rf /var/www/tahoelafs
  341. fi
  342. systemctl reload nginx
  343. fi
  344. systemctl stop tahoelafs-storage
  345. systemctl disable tahoelafs-storage
  346. rm /etc/systemd/system/tahoelafs-storage.service
  347. systemctl daemon-reload
  348. systemctl stop tahoelafs-client
  349. systemctl disable tahoelafs-client
  350. rm /etc/systemd/system/tahoelafs-client.service
  351. systemctl daemon-reload
  352. pip uninstall tahoe-lafs[tor]
  353. apt-get -yq remove tahoe-lafs
  354. if [ -d /var/lib/tahoelafs ]; then
  355. rm -rf /var/lib/tahoelafs
  356. fi
  357. remove_completion_param install_tahoelafs
  358. function_check remove_onion_service
  359. remove_onion_service tahoelafs ${TAHOELAFS_ONION_PORT}
  360. remove_onion_service storage-tahoelafs ${TAHOELAFS_STORAGE_ONION_PORT} "$(get_tahoelafs_nick)"
  361. sed -i '/HidServAuth /d' /etc/tor/torrc
  362. groupdel -f tahoelafs
  363. userdel -r tahoelafs
  364. if [ -d $TAHOE_DIR ]; then
  365. rm -rf $TAHOE_DIR
  366. fi
  367. remove_app tahoelafs
  368. if [ -f /etc/nginx/.htpasswd-tahoelafs ]; then
  369. rm /etc/nginx/.htpasswd-tahoelafs
  370. fi
  371. onion_update
  372. }
  373. function create_tahoelafs_stealth_node {
  374. node_dir="$1"
  375. client_dir="$2"
  376. node_nick="$3"
  377. client_nick="$4"
  378. if [ ${#node_dir} -eq 0 ]; then
  379. echo $'No tahoe-LAFS storage node directory given'
  380. exit 783522
  381. fi
  382. if [ ${#client_dir} -eq 0 ]; then
  383. echo $'No tahoe-LAFS client directory given'
  384. exit 368935
  385. fi
  386. if [ ${#node_nick} -eq 0 ]; then
  387. echo $'No tahoe-LAFS node nick given'
  388. exit 672351
  389. fi
  390. if [ ${#client_nick} -eq 0 ]; then
  391. echo $'No tahoe-LAFS client nick given'
  392. exit 682362
  393. fi
  394. if [ ! -f "${node_dir}/tahoe.cfg" ]; then
  395. su -c "mkdir ${node_dir}" - tahoelafs
  396. su -c "$TAHOE_COMMAND create-node -C ${node_dir} --hostname=fixme" - tahoelafs
  397. tahoelafs_setup_storage_config "${node_dir}/tahoe.cfg" "${node_nick}"
  398. fi
  399. if [ ! -f "${client_dir}/tahoe.cfg" ]; then
  400. su -c "mkdir ${client_dir}" - tahoelafs
  401. su -c "$TAHOE_COMMAND create-client -C ${client_dir}" - tahoelafs
  402. tahoelafs_setup_client_config "${client_dir}/tahoe.cfg" "${client_nick}"
  403. fi
  404. }
  405. function create_tahoelafs_introducer {
  406. introducer_dir="$1"
  407. if [ -f "${introducer_dir}/tahoe.cfg" ]; then
  408. return
  409. fi
  410. su -c "mkdir ${introducer_dir}" - tahoelafs
  411. su -c "$TAHOE_COMMAND create-introducer -C ${introducer_dir} --hide-ip --hostname=127.0.0.1" - tahoelafs
  412. }
  413. function create_tahoelafs_storage_node {
  414. # Nodes can store data
  415. node_dir="$1"
  416. furl="$2"
  417. if [ ${#furl} -eq 0 ]; then
  418. return
  419. fi
  420. if [ -f "${node_dir}/tahoe.cfg" ]; then
  421. return
  422. fi
  423. su -c "mkdir ${node_dir}" - tahoelafs
  424. su -c "$TAHOE_COMMAND create-node -C ${node_dir} --introducer=\"$furl\" --listen=tor --hide-ip" - tahoelafs
  425. }
  426. function create_tahoelafs_client {
  427. # Clients have no storage
  428. client_dir="$1"
  429. furl="$2"
  430. if [ ${#furl} -eq 0 ]; then
  431. return
  432. fi
  433. if [ -f "${client_dir}/tahoe.cfg" ]; then
  434. return
  435. fi
  436. su -c "mkdir ${client_dir}" - tahoelafs
  437. su -c "$TAHOE_COMMAND create-client -C ${client_dir} --introducer=\"$furl\" --listen=tor --hide-ip --hostname=127.0.0.1" - tahoelafs
  438. sed -i 's|reveal-IP-address =.*|reveal-IP-address = False|g' "$client_dir/tahoe.cfg"
  439. sed -i 's|tub.port =.*|tub.port = disabled|g' "$client_dir/tahoe.cfg"
  440. sed -i 's|tub.location =.*|tub.location = disabled|g' "$client_dir/tahoe.cfg"
  441. }
  442. function get_tahoelafs_furl {
  443. furl=$(cat $TAHOE_DIR/storage/private/storage.furl)
  444. furl_1=$(echo "${furl}" | awk -F ' ' '{print $1}')
  445. furl_2=$(echo "${furl}" | awk -F ':' '{print $5}')
  446. echo "${furl_1}:${furl_2}"
  447. }
  448. function get_tahoelafs_nick {
  449. echo "${MY_USERNAME}-node"
  450. }
  451. function get_tahoelafs_storage_hostname {
  452. cat /var/lib/tor/hidden_service_storage-tahoelafs/hostname
  453. }
  454. function get_tahoelafs_public_key {
  455. grep 'v0-' "$TAHOE_DIR/storage/node.pubkey" | sed 's|pub-||g'
  456. }
  457. function add_tahoelafs_server {
  458. storage_hostname="$1"
  459. public_key="$2"
  460. nick="$3"
  461. furl="$4"
  462. if [ ${#storage_hostname} -eq 0 ]; then
  463. echo $'No storage hostname'
  464. return
  465. fi
  466. if [ ${#public_key} -eq 0 ]; then
  467. echo $'No public key'
  468. return
  469. fi
  470. if [ ${#nick} -eq 0 ]; then
  471. echo $'No nick'
  472. return
  473. fi
  474. if [ ${#furl} -eq 0 ]; then
  475. echo $'No furl'
  476. return
  477. fi
  478. if [ ! -f ${tahoelafs_storage_file} ]; then
  479. echo 'storage:' > ${tahoelafs_storage_file}
  480. else
  481. if grep -q "${public_key}" ${tahoelafs_storage_file}; then
  482. echo $'Public key already exists'
  483. return
  484. fi
  485. echo '# storage' >> ${tahoelafs_storage_file}
  486. fi
  487. { echo " ${public_key}:";
  488. echo " ann:";
  489. echo " nickname: ${nick}";
  490. echo " anonymous-storage-FURL: ${furl}"; } >> "${tahoelafs_storage_file}"
  491. chown tahoelafs:debian-tor ${tahoelafs_storage_file}
  492. if ! grep -q "HidServAuth ${storage_hostname}" /etc/tor/torrc; then
  493. echo "HidServAuth ${storage_hostname}" >> /etc/tor/torrc
  494. fi
  495. }
  496. function create_tahoelafs_daemon {
  497. daemon_name=$1
  498. TAHOELAFS_DAEMON_FILE=/etc/systemd/system/tahoelafs-${daemon_name}.service
  499. echo "Creating daemon: $TAHOELAFS_DAEMON_FILE"
  500. { echo '[Unit]';
  501. echo "Description=Tahoe-LAFS ${daemon_name}";
  502. echo 'After=syslog.target';
  503. echo 'After=network.target';
  504. echo '';
  505. echo '[Service]';
  506. echo 'Type=simple';
  507. echo "User=tahoelafs";
  508. echo "Group=debian-tor";
  509. echo "WorkingDirectory=${TAHOE_DIR}";
  510. echo "ExecStart=/usr/bin/tahoe run ${TAHOE_DIR}/${daemon_name}";
  511. echo "ExecStop=/usr/bin/tahoe stop ${TAHOE_DIR}/${daemon_name}";
  512. echo 'Restart=on-failure';
  513. echo 'RestartSec=10';
  514. echo "Environment=\"USER=tahoelafs\" \"HOME=${TAHOE_DIR}\"";
  515. echo '';
  516. echo '[Install]';
  517. echo 'WantedBy=multi-user.target'; } > "$TAHOELAFS_DAEMON_FILE"
  518. systemctl enable "tahoelafs-${daemon_name}"
  519. systemctl daemon-reload
  520. systemctl start "tahoelafs-${daemon_name}"
  521. }
  522. function create_tahoelafs_web {
  523. if [ ! -d /var/www/tahoelafs/htdocs ]; then
  524. mkdir -p /var/www/tahoelafs/htdocs
  525. fi
  526. TAHOELAFS_LOGIN_TEXT=$'Tahoe-LAFS login'
  527. tahoelafs_nginx_site=/etc/nginx/sites-available/tahoelafs
  528. { echo 'server {';
  529. echo " listen 127.0.0.1:$TAHOELAFS_ONION_PORT default_server;";
  530. echo " server_name $TAHOELAFS_ONION_HOSTNAME;";
  531. echo ''; } > "$tahoelafs_nginx_site"
  532. function_check nginx_security_options
  533. nginx_security_options tahoelafs
  534. { echo '';
  535. echo ' # Logs';
  536. echo ' access_log /dev/null;';
  537. echo ' error_log /dev/null;';
  538. echo '';
  539. echo ' # Root';
  540. echo " root /var/www/tahoelafs/htdocs;";
  541. echo '';
  542. echo ' location / {';
  543. echo " auth_basic \"${TAHOELAFS_LOGIN_TEXT}\";";
  544. echo ' auth_basic_user_file /etc/nginx/.htpasswd-tahoelafs;'; } >> "$tahoelafs_nginx_site"
  545. function_check nginx_limits
  546. nginx_limits tahoelafs '15m'
  547. { echo " rewrite /(.*) /\$1 break;";
  548. echo " proxy_set_header X-Real-IP \$remote_addr;";
  549. echo " proxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
  550. echo " proxy_set_header Host \$http_host;";
  551. echo ' proxy_set_header X-NginX-Proxy true;';
  552. echo " proxy_pass http://localhost:${TAHOELAFS_PORT};";
  553. echo ' proxy_redirect off;';
  554. echo ' }';
  555. echo '}'; } >> "$tahoelafs_nginx_site"
  556. TAHOELAFS_ADMIN_PASSWORD="$(create_password "${MINIMUM_PASSWORD_LENGTH}")"
  557. "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a tahoelafs -p "$TAHOELAFS_ADMIN_PASSWORD"
  558. if [ ! -f /etc/nginx/.htpasswd-tahoelafs ]; then
  559. touch /etc/nginx/.htpasswd-tahoelafs
  560. fi
  561. if grep -q "${MY_USERNAME}:" /etc/nginx/.htpasswd-tahoelafs; then
  562. sed -i "/${MY_USERNAME}:/d" /etc/nginx/.htpasswd-tahoelafs
  563. fi
  564. echo "${TAHOELAFS_ADMIN_PASSWORD}" | htpasswd -i -s /etc/nginx/.htpasswd-tahoelafs "${MY_USERNAME}"
  565. function_check nginx_ensite
  566. nginx_ensite tahoelafs
  567. systemctl reload nginx
  568. }
  569. function install_tahoelafs {
  570. if [ "$INSTALLING_MESH" ]; then
  571. return
  572. fi
  573. apt-get -yq install build-essential python-pip python-dev libffi-dev libssl-dev
  574. apt-get -yq install libcrypto++-dev python-pycryptopp python-cffi
  575. apt-get -yq install python-virtualenv apache2-utils
  576. if [ -d $TAHOE_DIR ]; then
  577. groupdel -f tahoelafs
  578. userdel -r tahoelafs
  579. rm -rf $TAHOE_DIR
  580. fi
  581. # create a user
  582. adduser --disabled-login --gecos 'tahoe-lafs' tahoelafs
  583. if [ ! -d $TAHOE_DIR ]; then
  584. echo $"$TAHOE_DIR directory was not created"
  585. exit 879335
  586. fi
  587. adduser tahoelafs debian-tor
  588. groupadd tahoelafs
  589. apt-get -yq install tahoe-lafs
  590. pip install tahoe-lafs[tor]
  591. if [ -d $TAHOE_DIR/Maildir ]; then
  592. rm -rf $TAHOE_DIR/Maildir
  593. fi
  594. # remove files we don't need
  595. rm -rf $TAHOE_DIR/.mutt
  596. rm $TAHOE_DIR/.emacs-mutt
  597. rm $TAHOE_DIR/.muttrc
  598. rm $TAHOE_DIR/.mutt-alias
  599. rm $TAHOE_DIR/.procmailrc
  600. # set permissions
  601. chown -R tahoelafs:debian-tor $TAHOE_DIR
  602. node_nick=$(get_tahoelafs_nick)
  603. client_nick=${MY_USERNAME}-client
  604. # create an onion address for storage node
  605. TAHOELAFS_STORAGE_ONION_HOSTNAME=$(add_onion_service storage-tahoelafs ${TAHOELAFS_STORAGE_PORT} ${TAHOELAFS_STORAGE_ONION_PORT} "${node_nick}")
  606. # create an onion address for client node
  607. TAHOELAFS_ONION_HOSTNAME=$(add_onion_service tahoelafs 80 ${TAHOELAFS_ONION_PORT})
  608. create_tahoelafs_stealth_node "$TAHOE_DIR/storage" "$TAHOE_DIR/client" "${node_nick}" "${client_nick}"
  609. # start the storage node
  610. su -c "/usr/bin/python2 /usr/bin/tahoe start $TAHOE_DIR/storage" - tahoelafs
  611. create_tahoelafs_daemon "storage"
  612. # start the client
  613. su -c "/usr/bin/python2 /usr/bin/tahoe start $TAHOE_DIR/client" - tahoelafs
  614. add_tahoelafs_server "$(get_tahoelafs_storage_hostname)" "$(get_tahoelafs_public_key)" "${node_nick}" "$(get_tahoelafs_furl)"
  615. if ! grep -q "HidServAuth $(get_tahoelafs_storage_hostname)" /etc/tor/torrc; then
  616. echo $'Unable to create tahoelafs server'
  617. exit 738752
  618. fi
  619. if [ ! -f ${tahoelafs_storage_file} ]; then
  620. echo $'tahoelafs server file missing'
  621. exit 529362
  622. fi
  623. create_tahoelafs_daemon "client"
  624. set_completion_param "tahoelafs onion domain" "$TAHOELAFS_ONION_HOSTNAME"
  625. create_tahoelafs_web
  626. onion_update
  627. APP_INSTALLED=1
  628. }
  629. # NOTE: deliberately no exit 0